void setupIO()
{
  pinMode(11, OUTPUT); // set D13 outmode
  pinMode(10, OUTPUT); 
  pinMode(9, OUTPUT); 
  pinMode(8, OUTPUT); 
}

double caldiff(double t)
{
  int bufsize=10;
  buf[9]=buf[8]; 
  buf[8]=buf[7]; 
  buf[7]=buf[6]; 
  buf[6]=buf[5]; 
  buf[5]=buf[4]; 
  buf[4]=buf[3]; 
  buf[3]=buf[2]; 
  buf[2]=buf[1]; 
  buf[1]=buf[0]; 
  buf[0]=t; 
  
  double sum,average,diff;
  sum=0;
  for(int i=0;i<10;i++){sum+=buf[i];}
  average=sum/10.0;
  
  diff=0;
  diff+=buf[0]*+5;
  diff+=buf[1]*+4;
  diff+=buf[2]*+3;
  diff+=buf[3]*+2;
  diff+=buf[4]*+1;
  diff+=buf[5]*-1;
  diff+=buf[6]*-2;
  diff+=buf[7]*-3;
  diff+=buf[8]*-4;
  diff+=buf[9]*-5;
  diff=diff/10.0;
  
  return(diff);
}

double caldiff2(double t,int bufsize)
{
  // slide values of buf
  for(int i=0;i<bufsize-1;i++){
      buf[bufsize-i-1]=buf[bufsize-i-2];     
  }  
  buf[0]=t; 

  // cal integral
  diff=0;
  for(int i=0;i<bufsize/2;i++){
    diff+=buf[i]*(bufsize/2-i);
    diff+=buf[bufsize/2+i]*-(i+1);
  }
  diff=diff/(double)bufsize;
  
  return(diff);
}


