// Visual FB
void VFB(double d, double threshold)
{
  double power;
  power=map(abs(d),0,1023,0,255);
  
  analogWrite(9,0);  analogWrite(10,0);
  if(d>threshold){
    analogWrite(9,power);  analogWrite(10,0);
  }  
  if(d<threshold*-1){
    analogWrite(9,0);  analogWrite(10,power);  
  }
}

// Audio FB
void AFB(double d, double threshold)
{
  int Htone=1000;
  int Ltone=100;
  int duration=50;
  
  if(d>threshold){
    tone(8, Ltone, duration); 
  }  
  if(d<threshold*-1){
    tone(8, Htone, duration); 
  }   
}
