int dv,cnt,vinterval,ainterval;
int vthreshold,athreshold;
double temp,diff;
int vt,vt0,at,at0;
double buf[50];
int mode=68;

void setup() {
  vinterval=200;  // interval of Visual FB
  ainterval=1000; // interval of Audio FB
  vthreshold=5;   // threshold of Visual FB
  athreshold=10;  // threshold of Audio FB
  
  Serial.begin(57600);
  analogReference(INTERNAL);    //参照電圧を1.1Vにして感度拡大
  vt=0;
  vt0=0;
  dv=0;
  cnt=0;
  
  setupIO();
  establishContact();
}

void loop() {
  //mode=68;
  if (Serial.available()>0) {
    mode=Serial.read(); 
    ///////////
    Serial.print(temp);Serial.print(",");
    Serial.print(diff);Serial.print(",");
    Serial.print(cnt); Serial.print(",");
    Serial.print(mode); Serial.print(",");
    Serial.println("#");
  }
  
  dv = dv+analogRead(0);
  delay(2);
  cnt++;
  
  vt=millis()/vinterval;
  at=millis()/ainterval;
  /////////////////////////
  if(vt!=vt0){
    //temp=(double)dv/(double)cnt/1024*500.0;
    temp=(double)dv/(double)cnt/1024*110.0;
    //diff=caldiff(temp)*100;
    diff=caldiff2(temp,20)*100;
    if(mode==66){VFB(0,vthreshold);}    //AF
    if(mode==67){VFB(diff,vthreshold);} //VF
    if(mode==68){VFB(diff,vthreshold);} //AVF
    dv=0;
    cnt=0;
    vt0=vt;
  }
  //////////////////////////
  if(at!=at0){
    if(mode==66){AFB(diff,athreshold);}
    if(mode==67){AFB(0,athreshold);}
    if(mode==68){AFB(diff,athreshold);}
    at0=at;
  }
}

void establishContact() {
  // wait string from processing
  while (Serial.available() <= 0) {
    // string for initialize
    Serial.println("0,0"); 
    delay(300);
  }
}
